﻿using C1.WPF.Grid;
using C1.WPF.Input;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FlexGridStudyNet5
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        public ObservableCollection<Data> ListData { get; set; } = new();



        public MainWindow()
        {
            InitializeComponent();

            this.DataContext = this;

            ListData.Add(new Data() { Num = 1, Text = "aaa" });
            ListData.Add(new Data() { Text = "bbb" });
            ListData.Add(new Data() { Num = 3, Text = "ccc" });
        }


        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName) => PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        protected bool SetField<T>(ref T field, T value, [CallerMemberName] string propertyName = null)
        {
            if (EqualityComparer<T>.Default.Equals(field, value)) return false;
            field = value;
            OnPropertyChanged(propertyName);
            return true;
        }


        private void Prepare_Cell(object sender, GridCellEditEventArgs e)
        {
            if (e.Editor is C1NumericBox)
            {
                C1NumericBox editor = (e.Editor as C1NumericBox);
                editor.AllowNull = true;
                var gridValue = (sender as FlexGrid)[e.CellRange.Row, e.CellRange.Column];
                if (gridValue == null)
                    editor.Value = double.NaN;
                else
                    editor.Value = (double)gridValue;
            }
        }
    }

    public class Data : NotifyBase
    {



        private int? _num;
        public int? Num
        {
            get => _num;
            set => SetField(ref _num, value);
        }





        private string _text;
        public string Text
        {
            get => _text;
            set => SetField(ref _text, value);
        }



    }

}
